
#include "TestCygwinJNI.h"

#include <netdb.h>
#include <netinet/in.h>

JNIEXPORT jint JNICALL Java_TestCygwinJNI_getServByName
  (JNIEnv *env, jobject obj, jstring service, jstring proto)
{
  struct servent *entry;
  int pnum;
  const char *sname = (*env)->GetStringUTFChars(env, service, 0);
  const char *pname = (*env)->GetStringUTFChars(env, proto, 0);

  entry = getservbyname(sname, pname);

  (*env)->ReleaseStringUTFChars(env, proto, pname);
  (*env)->ReleaseStringUTFChars(env, service, sname);

  if (entry != NULL)
    pnum = htons (entry->s_port);
  else
    pnum = 0;

  return pnum;

}
